#include "test_usart.h"

void init_usart_1(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE); //  USARTx 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); //    USARTx

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_9 | GPIO_Pin_10; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOA, &GPIO_InitStruct);

    GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_USART1);
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_USART1);

    USART_InitStruct.USART_BaudRate = 9600; 
    USART_InitStruct.USART_WordLength =  USART_WordLength_8b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(USART1, &USART_InitStruct);
    USART_Cmd(USART1, ENABLE);
}

//    usart
void usart_1_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

void usart_rec(void)
{
    extern uint8_t buf_rec[];
    extern uint8_t i_buf_rec;
    
    buf_rec[i_buf_rec] = USART_ReceiveData(USART1);
    
    i_buf_rec++;
    if(i_buf_rec == S_BUF)
        i_buf_rec = 0;
}

void usart_trans(void)
{
    extern uint8_t buf_tr[];
    extern uint8_t i_buf_tr;
    
    USART_SendData(USART1, buf_tr[i_buf_tr]);
    
    i_buf_tr++;
    if(i_buf_tr == S_BUF)
        i_buf_tr = 0;
    
    USART_ITConfig(USART1, USART_IT_TXE, DISABLE);
}
